/*
 *  Help for PC version of Form Filler
 */
#include "globals.h"

extern void put_box_char (int x, int y, char ch);
extern void draw_a_box(int y1, int x1, int y2, int x2, int dflag);
extern void center (int line, char *text);
extern void fkeydefn(int line, int col, int fkey, char *text);
extern char Selection[];

/* in saveform.c: */
extern char Unable_To_Open[];

/* The ENDPAGE character is used to end a page. */
#define ENDPAGE '.'
/* Maximum number of help pages */
#define  MAXPG 20

void help(helpname)
char *helpname;
{
int c, done, line, maxpage, page;
FILE *helpfile;
long pagepos[MAXPG];
char *HelpIndex[MAXPG];
char helpstr[134];

    cls();
    /* open the help file */
    if ((helpfile = fopen(helpname,ReadBinary)) == NULL)
    {	draw_a_box(10,10,13,70,2);
	center(11,Unable_To_Open);
	center(12,helpname);
	fkeydefn(23,48,10,MainMenu);
        while ( gtkey() != F10) ;
        return;
    }

    for (page=0; page < MAXPG;)
	HelpIndex[page++]=NULL;

    maxpage = MAXPG - 1;
    for (done = page = 0; !done && page < maxpage; ++page)
    {	pagepos[page] = ftell(helpfile);
	line = 0;
        do
        {   if (fgets(helpstr,82,helpfile) == NULL)
            {	done = 1;
		*helpstr = '\0';
	    }
	    if (!line++)
		HelpIndex[page]=strdup(helpstr);
        } while (*helpstr != ENDPAGE && !done);
    }

    if(*helpstr != ENDPAGE) --page;
    if((maxpage = --page) < 0) return;

    page = 0;

    while(1)
    {	cls();

	draw_a_box(0,10,maxpage+4,70,2);
	draw_a_box(2,11,2,69,1);
	put_box_char(10,2,199);
	put_box_char(70,2,182);
	setcur(1,12);
	wstr("\1Available Help Topics:\2",1);
	for (c = 0; c <= maxpage; c++)
	  { setcur(c+3,12);
	    wstr(HelpIndex[c],1);
	  }
	setcur(23,0);
	wstr(Selection,0);

	c = '\0';
	while (c != '\n')	/* Display help when ENTER */
	{ setcur(page+3,12);
	  wchar(1);
	  wstr(HelpIndex[page],0);
	  c = gtkey();
	  setcur(page+3,12);
	  wchar(2);
	  wstr(HelpIndex[page],1);
	  switch (c)
	    { case UP:
	      case LEFT:
	      case BS:
		if (--page < 0)
			page = 0;
		break;
	      case DOWN:
	      case RIGHT:
	      case ' ':
		if (++page > maxpage)
			page = maxpage;
		break;
	      case F10:
	      case ESC:
		goto exit;
	    }
	}

	while (c != F10 && c != ESC)
	    {   cls();
	        /* Go to next page of help file and show same */
	        fseek(helpfile,pagepos[page],SEEK_SET);
		setcur(0,70);
		printf("Page%3d",page+1);
		wchar(1);
		setcur(line=0,0);
		while (line < 24)
	        {   if (fgets(helpstr,82,helpfile) == NULL) goto exit;
		    helpstr[strlen(helpstr)-1]='\0';	/* Remove NL */
	            if (*helpstr == ENDPAGE) break;
		    setcur(line,0);
	            if (line < 24) wstr(helpstr,1);
		    if (line++ == 0) wchar(2);
	        }
	        setcur(24,0);
		wstr(HelpMenu);
		line = 0;
		while (line==0)	/* Loop, getting keys until user tells
				   us to do something */
		  switch (c = gtkey())
		  { case PGUP:
		    case UP:
			if (--page < 0)
				page = 0;
			else
				line++;
			break;
		    case PGDN:
		    case DOWN:
			if (++page > maxpage)
				page = maxpage;
			else
				line++;
			break;
		    case F10:
		    case ESC:
			line++;
		  }
	    }
    }
/* Close help file and return */
exit:
    fclose(helpfile);

    for (page=0; page < MAXPG;page++)
	if (HelpIndex[page]!=NULL)
		free(HelpIndex[page]);

}
